// Display the time from the ds3231 and set it if desired
// Jed Margolin  6/23/2023

#include <stdio.h>
#include "pico/stdlib.h"
#include "hardware/i2c.h"
#include "clock.h"
#include "hardware/adc.h"
#include "hardware/spi.h"

void do_clock()
{
   state = 0;

/*
   // Test the LCD
   SetChrMode(); 
   lcd_text("hello dere");

   sleep_ms(2000);
*/

   SetCmdMode();    // set for commands
   lcd_byte(0x01);  // clear screen

   domsg(&msg2);
   sleep_ms(2000);

// write
// addr is ds3231 address = DSADR = 110 1000 = 0x68
//   unsigned char out_buffer[nbytes_out];   // first byte register address?
//   i2c_write_blocking(i2c_default, DSADR, out_buffer, nbytes_out, false);

//      out_buffer[0] = 0;     // test a write
//      out_buffer[1] = 0x5A;
//      i2c_write_blocking(i2c_default, DSADR, out_buffer, 2, false);

   while(1)
   {
      if(irq_flag)   // 4 ms interrupts, debounces and processes the switches
      {
         irq_flag = 0;

//         LED_break();

// read timer
//     unsigned char output[1]; // register address start?
//     unsigned char time_buffer[nbytes_in];
//     output[0] = 0;
//     i2c_write_blocking(i2c_default, DSADR, output, 1, true);  
//     i2c_read_blocking(i2c_default, DSADR, time_buffer, 7, false);

// Do the main state machine.
       (*state_ptr[state])();  // Use the state number as the index to the list of pointers to the state functions

/*
       if(irq_count == 250)
       {
          gpio_put(LED,nflag);
          nflag = nflag ^ 0x01;
       }
*/

      }  // end of irq_flag

   } // end while

   return;
}   // end of do_clock()
//==========================================================
//==========================================
void state0()    // state 0 - start with the message "Set the Clock"
{
   // Display the time
   if(irq_count == 250)
   {
      i2c_get_time();
   }

   if(irq_count == 125)   // display
   {
      domsg(&msg15);
//      SetCmdMode();    // set for commands
//      lcd_byte(0x01);  // clear screen

      domsg(&msg2);         // "hrs mins secs date""  (Secs, Mins, Hours, Day, Date,Year)
      lcd_wr_time(0xc0,time_buffer[HOURS]);  // hrs
      lcd_wr_time(0xc3,time_buffer[MINS]);   // mins
      lcd_wr_time(0xc7,time_buffer[SECS]);   // secs
      lcd_wr_time(0xcc,time_buffer[DATE]);   // date
   }

   if(switch3.press == 1)   // Next
   {
      switch3.press = 0;   // reset the flag

      clear_lcd(0x80);      // First line of LCD
      state = 1;
   }

}
//------------------
void state1()    // state 0 - start with the message "Set the Clock"
{
   SetCmdMode();    // set for commands
   lcd_byte(0x01);  // clear screen

   domsg(&msg4);         // "Set the Clock""

   save_count = irq_count + 1;

   if(save_count == 251)
     {save_count = 250;}

   state = 2;
}
//------------------
void state2()    // state 1 - Wait until the count has lasted one second
{
   if(irq_count == save_count)
   {
     clear_lcd(0x80);      // First line of LCD
     domsg(&msg5);         // "Set Hours""
     state = 3;
   }
}
//------------------
void state3()       // hours
{
    lcd_wr_time(0x8C,time_buffer[HOURS]);  // display hours

    if(switch1.press == 1)   // Increment
    {
       switch1.press = 0;   // reset the flag
       time_buffer[HOURS] = inc_bcd(time_buffer[HOURS],0x00,0x23);  // hours  0 - 23   max, min
    }

    if(switch2.press == 1)   // Decrement
    {
       switch2.press = 0;   // reset the flag
       time_buffer[HOURS] = dec_bcd(time_buffer[HOURS],0x00,0x23);
    }

    if(switch3.press == 1)   // Next
    {
       switch3.press = 0;   // reset the flag

       clear_lcd(0x80);      // First line of LCD
       domsg(&msg6);         // "Set Minutes"
       state = 4;
    }

}
//------------------
void state4()       // minutes
{
    lcd_wr_time(0x8C,time_buffer[MINS]);  // mins

    if(switch1.press == 1)   // Increment
    {
       switch1.press = 0;   // reset the flag
       time_buffer[MINS] = inc_bcd(time_buffer[MINS],0x00,0x59);
    }

    if(switch2.press == 1)   // Decrement
    {
       switch2.press = 0;   // reset the flag
       time_buffer[MINS] = dec_bcd(time_buffer[MINS],0x00,0x59);
    }

    if(switch3.press == 1)   // Next
    {
       switch3.press = 0;   // reset the flag

       clear_lcd(0x80);      // First line of LCD
       domsg(&msg7);         // "Set Day"
       state = 5;
    }

}
//------------------
void state5()       // day is 1 to 7
{
   unsigned char m, n, data;

//    lcd_wr_time(0x8C,time_buffer[DAY]);  // day of the week
    n = time_buffer[DAY] - 1;   // use it as an index
    lcd_wr_instr(0x8b);  // position
    for(m=0; m<3; m++)
    {
        data = day_array[n][m];
        lcd_wr_data(data);
    }

    if(switch1.press == 1)   // Increment
    {
       switch1.press = 0;   // reset the flag
       time_buffer[DAY] = (inc_bcd(time_buffer[DAY],0x01,0x07));
    }

    if(switch2.press == 1)   // Decrement
    {
       switch2.press = 0;   // reset the flag
       time_buffer[DAY] = ( dec_bcd(time_buffer[DAY],0x01,0x07));
    }

    if(switch3.press == 1)   // Next
    {
       switch3.press = 0;   // reset the flag

       clear_lcd(0x80);      // First line of LCD
       domsg(&msg8);         // "Set Date"
       state = 6;
    }

}
//------------------
void state6()       // date is 1 to 31
{
    lcd_wr_time(0x8C,time_buffer[DATE]);  // date

    if(switch1.press == 1)   // Increment
    {
       switch1.press = 0;   // reset the flag
       time_buffer[DATE] = (inc_bcd(time_buffer[DATE],0x01,0x31));
    }

    if(switch2.press == 1)   // Decrement
    {
       switch2.press = 0;   // reset the flag
       time_buffer[DATE] = (dec_bcd(time_buffer[DATE],0x01,0x31));
    }

    if(switch3.press == 1)   // Next
    {
       switch3.press = 0;   // reset the flag

       clear_lcd(0x80);      // First line of LCD
       domsg(&msg9);         // "Set Month"
       state = 7;
    }

}
//------------------
void state7()       // Month is 1 to 12
{
    unsigned char m, n, data;

//    lcd_wr_time(0x8C,time_buffer[MONTH]);  // month
     n = time_buffer[MONTH] - 1;   // use it as an index
     lcd_wr_instr(0x8b);  // position
     for(m=0; m<3; m++)
     {
         data = month_array[n][m];
         lcd_wr_data(data);
     }

    if(switch1.press == 1)   // Increment
    {
       switch1.press = 0;   // reset the flag
       time_buffer[MONTH] = (inc_bcd(time_buffer[MONTH],0x01,0x12));
    }

    if(switch2.press == 1)   // Decrement
    {
       switch2.press = 0;   // reset the flag
       time_buffer[MONTH] = (dec_bcd(time_buffer[MONTH],0x01,0x12));
    }

    if(switch3.press == 1)   // Next
    {
       switch3.press = 0;   // reset the flag

       clear_lcd(0x80);      // First line of LCD
       domsg(&msg10);         // "Set Year"
       state = 8;
    }

}
//------------------
void state8()       // Year is 2023 to 2099
{
    lcd_wr_time(0x8A,0x20);            // year
    lcd_wr_time(0x8C,time_buffer[YEAR]);  // year

    if(switch1.press == 1)   // Increment
    {
       switch1.press = 0;   // reset the flag
       time_buffer[YEAR] = (inc_bcd(time_buffer[YEAR],0x23,0x99));
    }

    if(switch2.press == 1)   // Decrement
    {
       switch2.press = 0;   // reset the flag
       time_buffer[YEAR] = (dec_bcd(time_buffer[YEAR],0x23,0x99));
    }

    if(switch3.press == 1)   // Next
    {
       switch3.press = 0;   // reset the flag

       clear_lcd(0x80);      // First line of LCD
       domsg(&msg11);        // "Set the Clock?"
       domsg(&msg12);        // "No  Yes"
       state = 9;
    }

}
//------------------
void state9()       // Make It So
{
   unsigned char m, n;

   if(switch1.press == 1)   // Yes
   {
      switch1.press = 0;   // reset the flag

      SetCmdMode();    // set for commands
      lcd_byte(0x01);  // clear screen

      time_buffer[SECS] = 0;  // make seconds zero
    
      // Set the clock
      m = 1;
      for(n=0; n<7; n++)
        { 
           out_buffer[m++] = time_buffer[n];
        }

        out_buffer[0] = 0;
        i2c_write_blocking(i2c_default, DSADR, out_buffer, 8, false);
    
        domsg(&msg13);       // "Done"
        state = 10;
    }

    if(switch2.press == 1)   // No
    {
       switch2.press = 0;   // reset the flag

       SetCmdMode();    // set for commands
       lcd_byte(0x01);  // clear screen

       domsg(&msg14);       // "Ok, not changed"
       state = 10;
    }

    if(switch3.press == 1)   // Next
    {
       switch3.press = 0;   // reset the flag
       state = 10;
    }

}
//------------------
void state10()       // for now, go back
{
   if(switch3.press == 1)   // Next
   {
      switch3.press = 0;   // reset the flag

      SetCmdMode();    // set for commands
      lcd_byte(0x01);  // clear screen

//      mode = 0;
      state = 0;
      domsg(&msg2);        // ds3231 message
      asm(" nop");         // for debugger
   }
}
//=========================================================
unsigned char dec_bcd(unsigned char time, unsigned char min, unsigned char max)
{
    unsigned char bcd0, bcd1;

    if(time == min)
    {
        return(max);
    }

    bcd0 = time & 0x0F;
    bcd1 = time>>4;

    bcd0--;
    if(bcd0 == 0xFF)
    {
       bcd0 = 0x09;
       bcd1 = bcd1 - 1;
    }

    time = bcd0 | (bcd1<<4);
    return(time);
}
//===================================================
unsigned char inc_bcd(unsigned char time, unsigned char min, unsigned char max)
{
    unsigned char bcd0, bcd1;

    if(time == max)
    {
        time = min;
        return(time);
    }

    bcd0 = time & 0x0F;
    bcd1 = time>>4;

    bcd0++;
    if(bcd0 == 10)
    {
       bcd0 = 0;
       bcd1 = bcd1 + 1;
    }

    time = bcd0 | (bcd1<<4);

    return(time);
}
//==========================================================
void i2c_get_time()
{
// read ds3231
   output[0] = 0;  // 3231 address
   i2c_write_blocking(i2c_default, DSADR, output, 1, true);  
   i2c_read_blocking(i2c_default, DSADR, time_buffer, 7, false);
}
//==========================================================
void do_switch(unsigned char bit, struct myswitch *sptr)    // Bit, switch structure
{
// Debounce and process the switch
// sptr points to the switch's data block
    sptr->debounce  = sptr->debounce <<1;    // shifts in a zero

    if( gpio_get(bit) )        // a zero has already been shifted in
    {
       sptr->debounce++ ;      // so make LSB a one
    }

// Debounced state is either 0x00 or 0xFF
    if(sptr->debounce == 0x00)  {sptr->state = 0x00;}
    if(sptr->debounce == 0xFF)  {sptr->state = 0x01;}

// process the switch
    if(sptr->state != sptr->old)     // we have a change in switch state
    {
       if( (sptr->old == 0x01) && (sptr->state == 0x00) )  // we have a switch press
       {
          sptr->press = 0x01;
          sptr->count = 0;        // clear the switch counter
       }

       if( (sptr->old == 0x00) && (sptr->state== 0x01) )  // we have a switch release
       {
          sptr->release = 0x01;
          sptr->count = 0;        // clear the switch counter       }
       }

       sptr->old = sptr->state;     // the new state is now the old state
    }

// We now know if a switch has been pressed (and how long it has been pressed)
//    and if a switch has been released
}
//================================================================
